float4x4 tW: WORLD ;        //the models world matrix
float4x4 tV: VIEW ;         //view matrix as set via Renderer (EX9)
float4x4 tWV: WORLDVIEW ;
float4x4 tWVP: WORLDVIEWPROJECTION ;
float4x4 tP: PROJECTION ;   //projection matrix as set via Renderer (EX9)

texture tex;

sampler samp = sampler_state { texture = (tex); };

#include <effects\PhongDirectional.fxh>

struct vsI
{
	float4 p0 : POSITION ;
	float3 n0 : NORMAL ;
	float2 t0 : TEXCOORD0 ;
	float4 c0 : TEXCOORD1 ;
	
};
struct vsO
{
	float4 p : POSITION ;
	float4 c : COLOR0 ;
	float2 t : TEXCOORD0 ;
};
struct psI
{
	float4 c : COLOR0 ;
	float2 t : TEXCOORD0 ;
};


vsO vsMaster(vsI i)
{
	vsO o = (vsO)0;		
	
	// GOURAUD PER VERTEX FLAT SHADING
    float3 LightDirV = normalize(-mul(lDir, tV));
    float3 NormV = normalize(mul(i.n0, tWV));
	float3 ViewDirV = -normalize(mul(i.p0, tWV));
    float4 col = i.c0; // = 1;   //disable here the vertex color
	col.rgb *= PhongDirectional(NormV, ViewDirV, LightDirV);
	o.c = col;

	o.p =  mul(i.p0, tWVP);
	
	o.t = i.t0;
    return o;
}

float4 psMaster(psI i) : COLOR
{   
	float4 c = float4(1,1,1,1);
	c = tex2D(samp, i.t.xy);
	return c * i.c;
}

technique FlatShading{
	pass p0{
		ShadeMode = Flat;
		VertexShader = compile vs_3_0 vsMaster();
		PixelShader = compile ps_3_0 psMaster();
	}
}

technique GouraudShading{
	pass p0{
		ShadeMode = Gouraud;
		VertexShader = compile vs_3_0 vsMaster();
		PixelShader = compile ps_3_0 psMaster();
	}
}